<template>
	<a-card :bordered="false">
		<s-table
			ref="tableRef"
			:columns="columns"
			:data="loadData"
			bordered
			:row-key="(record) => record.id"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('bizConfigAdd')">
						<template #icon><plus-outlined /></template>
						新增
					</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('bizConfigEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['bizConfigEdit', 'bizConfigDelete'], 'and')" />
						<a-button type="link" danger size="small" v-if="hasPerm('bizConfigDelete')" @click="deleteConfig(record)">删除</a-button>
					</a-space>
				</template>
				<template v-if="column.dataIndex === 'queueEfficiency'">
					{{record.queueEfficiency}}分钟
				</template>
				<template v-if="column.dataIndex === 'pullNumber'">
					{{record.pullNumber}}个
				</template>
				<template v-if="column.dataIndex === 'stopDuration'">
					{{record.stopDuration}}分钟
				</template>
				<template v-if="column.dataIndex === 'auditSwitch'">
					{{ $TOOL.dictTypeData('biz_switch', record.auditSwitch) }}
				</template>
				<template v-if="column.dataIndex === 'orderWeightSwitch'">
					{{ $TOOL.dictTypeData('biz_switch', record.orderWeightSwitch) }}
				</template>
				<template v-if="column.dataIndex === 'accessControlSwitch'">
					{{ $TOOL.dictTypeData('biz_switch', record.accessControlSwitch) }}
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="tableRef.refresh()" />
</template>

<script setup name="bizconfig">
	import { cloneDeep } from 'lodash-es'
	import Form from './form.vue'
	import bizConfigApi from '@/api/biz/bizConfigApi'
	import {ExclamationCircleOutlined} from '@ant-design/icons-vue';
	import {Modal} from 'ant-design-vue';
	import {createVNode} from 'vue';

	const tableRef = ref()
	const formRef = ref()
	const toolConfig = { refresh: true, height: true, columnSetting: true, striped: false }
	const loading = ref(false)
	const submitLoading = ref(false)
	const columns = [
		{
			title: '排队时效',
			dataIndex: 'queueEfficiency',
			align:'center'
		},
		{
			title: '时段下拉个数',
			dataIndex: 'pullNumber',
			align:'center'
		},
		{
			title: '停留时长',
			dataIndex: 'stopDuration',
			align:'center'
		},
		{
			title: '预约审核开关',
			dataIndex: 'auditSwitch',
			align:'center'
		},
		{
			title: '订单重量校验开关',
			dataIndex: 'orderWeightSwitch',
			align:'center'
		},
		{
			title: '门禁强制校验开关',
			dataIndex: 'accessControlSwitch',
			align:'center'
		},
	]
	// 操作栏通过权限判断是否显示
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: 150
	})

	const selectedRowKeys = ref([])
	// 列表选择配置
	const options = {
		// columns数字类型字段加入 needTotal: true 可以勾选自动算账
		alert: {
			show: true,
			clear: () => {
				selectedRowKeys.value = ref([])
			}
		},
		rowSelection: {
			onChange: (selectedRowKey, selectedRows) => {
				selectedRowKeys.value = selectedRowKey
			}
		}
	}
	const loadData = (parameter) => {
		return bizConfigApi.bizConfigPage(parameter).then((data) => {
			return data
		})
	}
	// 重置
	const reset = () => {
		searchFormRef.value.resetFields()
		tableRef.value.refresh(true)
	}
	// 删除
	const deleteBizConfig = (record) => {
		let params = [
			{
				id: record.id
			}
		]
		bizConfigApi.bizConfigDelete(params).then(() => {
			tableRef.value.refresh(true)
		})
	}

	// 删除
	const deleteConfig = (record) => {

		Modal.confirm({
			title: '确定删除该数据吗？',
			icon: createVNode(ExclamationCircleOutlined),
			content: '',
			onOk() {
				submitLoading.value = true
				let params = [
					{
						id: record.id
					}
				]

				bizConfigApi
					.bizConfigDelete(params)
					.then(() => {
						tableRef.value.refresh(true)
					})
					.finally(() => {
						submitLoading.value = false
					})
			},
			onCancel() {}
		})
	}
	// 批量删除
	const deleteBatchBizConfig = (params) => {
		bizConfigApi.bizConfigDelete(params).then(() => {
			tableRef.value.clearRefreshSelected()
		})
	}
</script>
